<?php
namespace MyProject\Tests;

use MyProject\FizzBuzz;

class FizzBuzzTest extends \PHPUnit_Framework_TestCase
{
    private $fizzbuzz;

    public function setUp()
    {
        $this->fizzbuzz = new FizzBuzz();
    }

    public function tearDown()
    {
        $this->fizzbuzz = null;
    }

    public function integersNotMultipleOfThreeOrFive()
    {
        return array(
            array(1),
            array(11),
            array(23),
            array(97),
        );
    }

    /**
     * @test
     * @dataProvider integersNotMultipleOfThreeOrFive
     */
    public function ofReturnsIntegerWhenNotMultiple($int)
    {
        $this->assertEquals(
            $int,
            $this->fizzbuzz->of($int)
        );
    }

    public function integersMultipleOfThree()
    {
        return array(
            array(3),
            array(12),
            array(21),
            array(99),
        );
    }

    /**
     * @test
     * @dataProvider integersMultipleOfThree
     */
    public function ofReturnsFizzForMultipleOfThree($int)
    {
        $this->assertEquals(
            'Fizz',
            $this->fizzbuzz->of($int)
        );
    }

    public function integersMultipleOfFive()
    {
        return array(
            array(5),
            array(10),
            array(35),
            array(95),
        );
    }

    /**
     * @test
     * @dataProvider integersMultipleOfFive
     */
    public function ofReturnsBuzzForMultipleOfFive($int)
    {
        $this->assertEquals(
            'Buzz',
            $this->fizzbuzz->of($int)
        );
    }

    public function integersMultipleOfThreeAndFive()
    {
        return array(
            array(15),
            array(30),
            array(90),
        );
    }

    /**
     * @test
     * @dataProvider integersMultipleOfThreeAndFive
     */
    public function ofReturnsFizzBuzzMultipleOfBoth($int)
    {
        $this->assertEquals(
            'FizzBuzz',
            $this->fizzbuzz->of($int)
        );
    }
}
